@testitem "Basic Shooting" begin
    using BoundaryValueDiffEqShooting, LinearAlgebra, OrdinaryDiffEqTsit5

    # JET tests have been moved to the separate QA test group (test/qa/)

    SOLVERS = [
        Shooting(Tsit5(), NewtonRaphson(; autodiff = AutoFiniteDiff())),
        Shooting(Tsit5(), NewtonRaphson(; autodiff = AutoForwardDiff(; chunksize = 2))),
        Shooting(Tsit5()),
        MultipleShooting(10, Tsit5(), NewtonRaphson(; autodiff = AutoFiniteDiff())),
        MultipleShooting(
            10, Tsit5(), NewtonRaphson(;
                autodiff = AutoForwardDiff(; chunksize = 2)
            )
        ),
        MultipleShooting(10, Tsit5()),
    ]

    tspan = (0.0, 100.0)
    u0 = [0.0, 1.0]
    # Inplace
    function f1!(du, u, p, t)
        du[1] = u[2]
        du[2] = -u[1]
        return nothing
    end

    function bc1!(resid, sol, p, t)
        t₀, t₁ = first(t), last(t)
        resid[1] = sol(t₀)[1]
        resid[2] = sol(t₁)[1] - 1
        return nothing
    end

    bvp1 = BVProblem(f1!, bc1!, u0, tspan)
    @test SciMLBase.isinplace(bvp1)

    for (i, solver) in enumerate(SOLVERS)
        sol = solve(
            bvp1, solver; abstol = 1.0e-8, reltol = 1.0e-8,
            odesolve_kwargs = (; abstol = 1.0e-8, reltol = 1.0e-8), maxiters = 10000
        )

        @test SciMLBase.successful_retcode(sol)
        @test norm(sol.resid, Inf) < 1.0e-8
    end

    # Out of Place
    f1(u, p, t) = [u[2], -u[1]]

    function bc1(sol, p, t)
        t₀, t₁ = first(t), last(t)
        return [sol(t₀)[1], sol(t₁)[1] - 1]
    end

    @test_throws SciMLBase.NonconformingFunctionsError BVProblem(f1!, bc1, u0, tspan)
    @test_throws SciMLBase.NonconformingFunctionsError BVProblem(f1, bc1!, u0, tspan)

    bvp2 = BVProblem(f1, bc1, u0, tspan)
    @test !SciMLBase.isinplace(bvp2)

    for (i, solver) in enumerate(SOLVERS)
        sol = solve(
            bvp2, solver; abstol = 1.0e-8, reltol = 1.0e-8,
            odesolve_kwargs = (; abstol = 1.0e-6, reltol = 1.0e-3), maxiters = 10000
        )

        @test SciMLBase.successful_retcode(sol)
        @test norm(sol.resid, Inf) < 1.0e-8
    end

    # Inplace
    bc2a!(resid, ua, p) = (resid[1] = ua[1])
    bc2b!(resid, ub, p) = (resid[1] = ub[1] - 1)

    bvp3 = TwoPointBVProblem(
        f1!, (bc2a!, bc2b!), u0, tspan;
        bcresid_prototype = (Array{Float64}(undef, 1), Array{Float64}(undef, 1))
    )
    @test SciMLBase.isinplace(bvp3)

    for (i, solver) in enumerate(SOLVERS)
        sol = solve(
            bvp3, solver; abstol = 1.0e-8, reltol = 1.0e-8,
            odesolve_kwargs = (; abstol = 1.0e-6, reltol = 1.0e-3), maxiters = 10000
        )

        @test SciMLBase.successful_retcode(sol)
        @test norm(sol.resid, Inf) < 1.0e-8
    end

    # Out of Place
    bc2a(ua, p) = [ua[1]]
    bc2b(ub, p) = [ub[1] - 1]

    bvp4 = TwoPointBVProblem(f1, (bc2a, bc2b), u0, tspan)
    @test !SciMLBase.isinplace(bvp4)

    for (i, solver) in enumerate(SOLVERS)
        sol = solve(
            bvp4, solver; abstol = 1.0e-8, reltol = 1.0e-8,
            odesolve_kwargs = (; abstol = 1.0e-6, reltol = 1.0e-3), maxiters = 10000
        )

        @test SciMLBase.successful_retcode(sol)
        @test norm(sol.resid, Inf) < 1.0e-8
    end
end

@testitem "Shooting with Complex Values" begin
    using BoundaryValueDiffEqShooting, OrdinaryDiffEqVerner, LinearAlgebra

    SOLVERS = [
        Shooting(Vern7(), NewtonRaphson(; autodiff = AutoFiniteDiff())), Shooting(Vern7()),
        MultipleShooting(10, Vern7(), NewtonRaphson(; autodiff = AutoFiniteDiff())),
        MultipleShooting(10, Vern7()),
    ]

    function f1!(du, u, p, t)
        du[1] = u[2]
        du[2] = -u[1]
        return nothing
    end

    function bc1!(resid, sol, p, t)
        t₀, t₁ = first(t), last(t)
        resid[1] = sol(t₀)[1]
        resid[2] = sol(t₁)[1] - 1
        return nothing
    end

    tspan = (0.0, 100.0)
    u0 = [0.0, 1.0] .+ 1im
    bvp = BVProblem(f1!, bc1!, u0, tspan)

    for (i, solver) in enumerate(SOLVERS)
        sol = solve(
            bvp, solver; abstol = 1.0e-8, reltol = 1.0e-8,
            odesolve_kwargs = (; abstol = 1.0e-8, reltol = 1.0e-8), maxiters = 10000
        )

        @test SciMLBase.successful_retcode(sol)
        @test norm(sol.resid, Inf) < 1.0e-8
    end
end

@testitem "Flow in a Channel" begin
    using BoundaryValueDiffEqShooting, OrdinaryDiffEqTsit5, OrdinaryDiffEqRosenbrock,
        LinearAlgebra

    function flow_in_a_channel!(du, u, p, t)
        R, P = p
        A, f′′, f′, f, h′, h, θ′, θ = u
        du[1] = 0
        du[2] = R * (f′^2 - f * f′′) - R * A
        du[3] = f′′
        du[4] = f′
        du[5] = -R * f * h′ - 1
        du[6] = h′
        du[7] = -P * f * θ′
        du[8] = θ′
    end

    function bc_flow!(resid, sol, p, tspan)
        t₁, t₂ = extrema(tspan)
        solₜ₁ = sol(t₁)
        solₜ₂ = sol(t₂)
        resid[1] = solₜ₁[4]
        resid[2] = solₜ₁[3]
        resid[3] = solₜ₂[4] - 1
        resid[4] = solₜ₂[3]
        resid[5] = solₜ₁[6]
        resid[6] = solₜ₂[6]
        resid[7] = solₜ₁[8]
        resid[8] = solₜ₂[8] - 1
    end

    tspan = (0.0, 1.0)
    p = [10.0, 7.0]
    u0 = zeros(8)

    flow_bvp = BVProblem{true}(flow_in_a_channel!, bc_flow!, u0, tspan, p)

    for solver in [
            Shooting(
                AutoTsit5(Rodas4P()), NewtonRaphson(;
                    autodiff = AutoForwardDiff(; chunksize = 8)
                )
            ),
            MultipleShooting(
                10, AutoTsit5(Rodas4P()),
                NewtonRaphson(; autodiff = AutoForwardDiff(; chunksize = 8))
            ),
        ]
        sol = solve(
            flow_bvp, solver; abstol = 1.0e-8, reltol = 1.0e-8,
            odesolve_kwargs = (; abstol = 1.0e-8, reltol = 1.0e-8)
        )

        @test SciMLBase.successful_retcode(sol)
        @test norm(sol.resid, Inf) < 1.0e-8
    end
end
#FIXME: MultipleShooting fails for large out-of-place BVP systems
@testitem "Ray Tracing" begin
    using BoundaryValueDiffEqShooting, OrdinaryDiffEqVerner, OrdinaryDiffEqRosenbrock,
        LinearAlgebra

    @inline v(x, y, z, p) = 1 / (4 + cos(p[1] * x) + sin(p[2] * y) - cos(p[3] * z))
    @inline ux(x, y, z, p) = -p[1] * sin(p[1] * x)
    @inline uy(x, y, z, p) = p[2] * cos(p[2] * y)
    @inline uz(x, y, z, p) = p[3] * sin(p[3] * z)

    function ray_tracing(u, p, t)
        x, y, z, ξ, η, ζ, T, S = u

        nu = v(x, y, z, p) # Velocity of a sound wave, function of space;
        μx = ux(x, y, z, p) # ∂(slowness)/∂x, function of space
        μy = uy(x, y, z, p) # ∂(slowness)/∂y, function of space
        μz = uz(x, y, z, p) # ∂(slowness)/∂z, function of space

        return [S * nu * ξ, S * nu * η, S * nu * ζ, S * μx, S * μy, S * μz, S / nu, 0]
    end

    function ray_tracing!(du, u, p, t)
        x, y, z, ξ, η, ζ, T, S = u

        nu = v(x, y, z, p) # Velocity of a sound wave, function of space;
        μx = ux(x, y, z, p) # ∂(slowness)/∂x, function of space
        μy = uy(x, y, z, p) # ∂(slowness)/∂y, function of space
        μz = uz(x, y, z, p) # ∂(slowness)/∂z, function of space

        du[1] = S * nu * ξ
        du[2] = S * nu * η
        du[3] = S * nu * ζ

        du[4] = S * μx
        du[5] = S * μy
        du[6] = S * μz

        du[7] = S / nu
        du[8] = 0

        return nothing
    end

    function ray_tracing_bc(sol, p, t)
        ua = sol(0.0)
        ub = sol(1.0)
        nu = v(ua[1], ua[2], ua[3], p) # Velocity of a sound wave, function of space;

        return [
            ua[1] - p[4], ua[2] - p[5], ua[3] - p[6],
            ua[7], ua[4]^2 + ua[5]^2 + ua[6]^2 - 1 / nu^2,
            ub[1] - p[7], ub[2] - p[8], ub[3] - p[9],
        ]
    end

    function ray_tracing_bc!(res, sol, p, t)
        ua = sol(0.0)
        ub = sol(1.0)
        nu = v(ua[1], ua[2], ua[3], p) # Velocity of a sound wave, function of space;

        res[1] = ua[1] - p[4]
        res[2] = ua[2] - p[5]
        res[3] = ua[3] - p[6]
        res[4] = ua[7]      # T(0) = 0
        res[5] = ua[4]^2 + ua[5]^2 + ua[6]^2 - 1 / nu^2
        res[6] = ub[1] - p[7]
        res[7] = ub[2] - p[8]
        res[8] = ub[3] - p[9]
        return nothing
    end

    function ray_tracing_bc_a(ua, p)
        resa = similar(ua, 5)
        ray_tracing_bc_a!(resa, ua, p)
        return resa
    end

    function ray_tracing_bc_a!(resa, ua, p)
        nu = v(ua[1], ua[2], ua[3], p) # Velocity of a sound wave, function of space;

        resa[1] = ua[1] - p[4]
        resa[2] = ua[2] - p[5]
        resa[3] = ua[3] - p[5]
        resa[4] = ua[7]
        resa[5] = ua[4]^2 + ua[5]^2 + ua[6]^2 - 1 / nu^2

        return nothing
    end

    function ray_tracing_bc_b(ub, p)
        resb = similar(ub, 3)
        ray_tracing_bc_b!(resb, ub, p)
        return resb
    end

    function ray_tracing_bc_b!(resb, ub, p)
        resb[1] = ub[1] - p[7]
        resb[2] = ub[2] - p[8]
        resb[3] = ub[3] - p[9]
        return nothing
    end

    p = [0, 1, 2, 0, 0, 0, 4, 3, 2.0]

    dx = p[7] - p[4]
    dy = p[8] - p[5]
    dz = p[9] - p[6]

    u0 = zeros(8)
    u0[1:3] .= 0 # position
    u0[4] = dx / v(p[4], p[5], p[6], p)
    u0[5] = dy / v(p[4], p[5], p[6], p)
    u0[6] = dz / v(p[4], p[5], p[6], p)
    u0[8] = 1

    tspan = (0.0, 1.0)

    prob_oop = BVProblem(
        BVPFunction{false}(ray_tracing, ray_tracing_bc), u0, tspan, p; nlls = Val(true)
    )
    prob_iip = BVProblem(
        BVPFunction{true}(ray_tracing!, ray_tracing_bc!), u0, tspan, p; nlls = Val(true)
    )
    prob_tp_oop = BVProblem(
        BVPFunction{false}(ray_tracing, (ray_tracing_bc_a, ray_tracing_bc_b); twopoint = Val(true)),
        u0,
        tspan,
        p;
        nlls = Val(true)
    )
    prob_tp_iip = BVProblem(
        BVPFunction{true}(
            ray_tracing!, (ray_tracing_bc_a!, ray_tracing_bc_b!);
            bcresid_prototype = (zeros(5), zeros(3)), twopoint = Val(true)
        ),
        u0,
        tspan,
        p;
        nlls = Val(true)
    )

    alg_sp = MultipleShooting(
        10,
        AutoVern7(Rodas4P());
        grid_coarsening = true,
        nlsolve = TrustRegion(),
        jac_alg = BVPJacobianAlgorithm(;
            bc_diffmode = AutoForwardDiff(; chunksize = 8),
            nonbc_diffmode = AutoSparse(AutoForwardDiff(; chunksize = 8))
        )
    )
    alg_dense = MultipleShooting(
        10,
        AutoVern7(Rodas4P());
        grid_coarsening = true,
        nlsolve = TrustRegion(),
        jac_alg = BVPJacobianAlgorithm(;
            bc_diffmode = AutoForwardDiff(; chunksize = 8),
            nonbc_diffmode = AutoForwardDiff(; chunksize = 8)
        )
    )
    alg_default = MultipleShooting(10, AutoVern7(Rodas4P()); nlsolve = NewtonRaphson(), grid_coarsening = true)

    for (prob, alg) in
        Iterators.product((prob_iip, prob_tp_iip), (alg_sp, alg_dense, alg_default))
        sol = solve(
            prob, alg; abstol = 1.0e-6, reltol = 1.0e-6, maxiters = 1000,
            odesolve_kwargs = (; abstol = 1.0e-8, reltol = 1.0e-5)
        )

        @test SciMLBase.successful_retcode(sol.retcode)
        @test norm(sol.resid, Inf) < 1.0e-6
    end
end

@testitem "Shooting with heterogeneous initial guess" begin
    using BoundaryValueDiffEqShooting, OrdinaryDiffEqVerner, LinearAlgebra
    g = 9.81
    L = 1.0
    tspan = (0.0, pi / 2.0)
    function simplependulum!(du, u, p, t)
        θ = u[1]
        dθ = u[2]
        du[1] = dθ
        du[2] = -(g / L) * sin(θ)
    end

    function bc2a!(resid_a, u_a, p)
        resid_a[1] = u_a[1] + pi / 2
    end
    function bc2b!(resid_b, u_b, p)
        resid_b[1] = u_b[1] - pi / 2
    end

    function initialGuess(p, t)
        u1 = t * (-3.1444 * t + 6.9895) - 1.5708
        u2 = t * (t * (6.3342 * t - 19.208) + 9.6822) + 3.9882
        return [u1, u2]
    end

    u0 = [pi / 2, pi / 2]
    bvp2 = TwoPointBVProblem(
        simplependulum!, (bc2a!, bc2b!), u0, tspan;
        bcresid_prototype = (zeros(1), zeros(1))
    )
    sol2 = solve(bvp2, MultipleShooting(5, Vern7()))
    @test SciMLBase.successful_retcode(sol2)

    bvp3 = TwoPointBVProblem(
        simplependulum!, (bc2a!, bc2b!), sol2, tspan;
        bcresid_prototype = (zeros(1), zeros(1))
    )
    sol3 = solve(bvp3, MultipleShooting(5, Vern7()))
    @test SciMLBase.successful_retcode(sol3)

    bvp4 = TwoPointBVProblem(
        simplependulum!, (bc2a!, bc2b!), sol2.u, tspan;
        bcresid_prototype = (zeros(1), zeros(1))
    )
    sol4 = solve(bvp4, MultipleShooting(5, Vern7()))
    @test SciMLBase.successful_retcode(sol4)

    bvp5 = TwoPointBVProblem(
        simplependulum!, (bc2a!, bc2b!), initialGuess,
        tspan; bcresid_prototype = (zeros(1), zeros(1))
    )
    sol5 = solve(bvp5, MultipleShooting(5, Vern7()))
    @test SciMLBase.successful_retcode(sol5)
end

# Algorithms
abstract type AbstractShooting <: AbstractBoundaryValueDiffEqAlgorithm end

"""
    Shooting(ode_alg; kwargs...)
    Shooting(ode_alg, nlsolve; kwargs...)
    Shooting(; ode_alg = nothing, nlsolve = nothing, optimize = nothing, jac_alg = nothing)

Single shooting method, reduces BVP to an initial value problem and solves the IVP.

## Arguments

  - `ode_alg`: ODE algorithm to use for solving the IVP. Any solver which conforms to the
    SciML `ODEProblem` interface can be used! (Defaults to `nothing` which will use
    poly-algorithm if `DifferentialEquations.jl` is loaded else this must be supplied)
  - `nlsolve`: Internal Nonlinear solver. Any solver which conforms to the SciML
    `NonlinearProblem` interface can be used. Note that any autodiff argument for the solver
    will be ignored and a custom jacobian algorithm will be used.
  - `optimize`: Internal Optimization solver. Any solver which conforms to the SciML
    `OptimizationProblem` interface can be used. Note that any autodiff argument for the solver
    will be ignored and a custom jacobian algorithm will be used.
  - `jac_alg`: Jacobian Algorithm used for the Nonlinear Solver. If this is not set, we
    check if `nlsolve.ad` exists and is not nothing. If it is, we use that to construct
    the jacobian. If not, we try to use the best algorithm based on the input types
    and problem type. If `BVPJacobianAlgorithm` is provided, only `diffmode` is used
    (defaults to `AutoForwardDiff` if possible else `AutoFiniteDiff`).
"""
@concrete struct Shooting{J <: BVPJacobianAlgorithm} <: AbstractShooting
    ode_alg
    nlsolve
    optimize
    jac_alg::J
end

function Shooting(; ode_alg = nothing, nlsolve = nothing, optimize = nothing, jac_alg = nothing)
    return Shooting(ode_alg, nlsolve, optimize, __materialize_jacobian_algorithm(nlsolve, jac_alg))
end
@inline Shooting(ode_alg; kwargs...) = Shooting(; ode_alg, kwargs...)
@inline Shooting(ode_alg, nlsolve; kwargs...) = Shooting(; ode_alg, nlsolve, kwargs...)

@inline function concretize_jacobian_algorithm(alg::Shooting, prob)
    alg.jac_alg.diffmode === nothing &&
        (return @set alg.jac_alg.diffmode = __default_nonsparse_ad(prob.u0))
    return alg
end

"""
    MultipleShooting(; nshoots::Int, ode_alg = nothing, nlsolve = nothing,
        optimize = nothing, grid_coarsening = true, jac_alg = nothing)
    MultipleShooting(nshoots::Int; kwargs...)
    MultipleShooting(nshoots::Int, ode_alg; kwargs...)
    MultipleShooting(nshoots::Int, ode_alg, nlsolve; kwargs...)

Multiple Shooting method, reduces BVP to an initial value problem and solves the IVP.
Significantly more stable than Single Shooting.

## Arguments

  - `nshoots`: Number of shooting points.

  - `ode_alg`: ODE algorithm to use for solving the IVP. Any solver which conforms to the
    SciML `ODEProblem` interface can be used! (Defaults to `nothing` which will use
    poly-algorithm if `DifferentialEquations.jl` is loaded else this must be supplied)
  - `nlsolve`: Internal Nonlinear solver. Any solver which conforms to the SciML
    `NonlinearProblem` interface can be used.
  - `optimize`: Internal Optimization solver. Any solver which conforms to the SciML
    `OptimizationProblem` interface can be used.
  - `jac_alg`: Jacobian Algorithm used for the nonlinear solver. Defaults to
    `BVPJacobianAlgorithm()`, which automatically decides the best algorithm to use based
    on the input types and problem type.

      + For `TwoPointBVProblem`, only `diffmode` is used (defaults to
        `AutoSparse(AutoForwardDiff())` if possible else `AutoSparse(AutoFiniteDiff())`).
      + For `BVProblem`, `bc_diffmode` and `nonbc_diffmode` are used. For `nonbc_diffmode`
        we default to `AutoSparse(AutoForwardDiff())` if possible else
        `AutoSparse(AutoFiniteDiff())`. For `bc_diffmode`, we default to `AutoForwardDiff`
        if possible else `AutoFiniteDiff`.
  - `grid_coarsening`: Coarsening the multiple-shooting grid to generate a stable IVP
    solution. Possible Choices:

      + `true`: Halve the grid size, till we reach a grid size of 1.
      + `false`: Do not coarsen the grid. Solve a Multiple Shooting Problem and finally
        solve a Single Shooting Problem.
      + `AbstractVector{<:Int}` or `Ntuple{N, <:Integer}`: Use the provided grid coarsening.
        For example, if `nshoots = 10` and `grid_coarsening = [5, 2]`, then the grid will be
        coarsened to `[5, 2]`. Note that `1` should not be present in the grid coarsening.
      + `Function`: Takes the current number of shooting points and returns the next number
        of shooting points. For example, if `nshoots = 10` and
        `grid_coarsening = n -> n ÷ 2`, then the grid will be coarsened to `[5, 2]`.
"""
@concrete struct MultipleShooting{J <: BVPJacobianAlgorithm} <: AbstractShooting
    ode_alg
    nlsolve
    optimize
    jac_alg::J
    nshoots::Int
    grid_coarsening
end

function concretize_jacobian_algorithm(alg::MultipleShooting, prob)
    jac_alg = concrete_jacobian_algorithm(alg.jac_alg, prob, alg)
    return MultipleShooting(
        alg.ode_alg, alg.nlsolve, alg.optimize, jac_alg, alg.nshoots, alg.grid_coarsening
    )
end

function update_nshoots(alg::MultipleShooting, nshoots::Int)
    return MultipleShooting(
        alg.ode_alg, alg.nlsolve, alg.optimize, alg.jac_alg, nshoots, alg.grid_coarsening
    )
end

function MultipleShooting(;
        nshoots::Int,
        ode_alg = nothing,
        nlsolve = nothing,
        optimize = nothing,
        grid_coarsening::Union{
            Bool, Function, <:AbstractVector{<:Integer}, Tuple{Vararg{Integer}},
        } = true,
        jac_alg = nothing
    )
    grid_coarsening isa Tuple && (grid_coarsening = Vector(grid_coarsening...))
    if grid_coarsening isa AbstractVector
        sort!(grid_coarsening; rev = true)
        @assert all(grid_coarsening .> 0) && 1 ∉ grid_coarsening
    end
    return MultipleShooting(
        ode_alg, nlsolve, optimize,
        __materialize_jacobian_algorithm(nlsolve, jac_alg), nshoots, grid_coarsening
    )
end
@inline MultipleShooting(nshoots::Int; kwargs...) = MultipleShooting(; nshoots, kwargs...)
@inline MultipleShooting(nshoots::Int, ode_alg; kwargs...) = MultipleShooting(; nshoots, ode_alg, kwargs...)
@inline MultipleShooting(
    nshoots::Int, ode_alg, nlsolve;
    kwargs...
) = MultipleShooting(; nshoots, ode_alg, nlsolve, kwargs...)

module BoundaryValueDiffEqShooting

using ADTypes
using ArrayInterface: fast_scalar_indexing
using BandedMatrices: BandedMatrix, Ones
using BoundaryValueDiffEqCore: AbstractBoundaryValueDiffEqAlgorithm, BVPJacobianAlgorithm,
    recursive_flatten, recursive_flatten!, recursive_unflatten!,
    __concrete_solve_algorithm, diff!, __any_sparse_ad,
    __cache_trait, concrete_jacobian_algorithm, eval_bc_residual,
    eval_bc_residual!, get_tmp, __maybe_matmul!,
    __concrete_kwargs, __extract_problem_details,
    __initial_guess, __construct_internal_problem,
    __default_coloring_algorithm, __default_sparsity_detector,
    __maybe_allocate_diffcache, __get_bcresid_prototype,
    safe_similar, __vec, __vec_f, __vec_f!, __vec_bc, __vec_bc!,
    __materialize_jacobian_algorithm, __default_nonsparse_ad,
    recursive_flatten_twopoint!, __internal_nlsolve_problem,
    NoDiffCacheNeeded, DiffCacheNeeded, __extract_mesh,
    __extract_u0, __has_initial_guess, __initial_guess_length,
    __initial_guess_on_mesh, __flatten_initial_guess,
    __get_non_sparse_ad, __build_solution, __Fix3, get_dense_ad,
    __internal_solve

using ConcreteStructs: @concrete
using DifferentiationInterface: DifferentiationInterface, Constant, prepare_jacobian,
    overloaded_input_type
using FastClosures: @closure
using ForwardDiff: ForwardDiff, pickchunksize
using LinearAlgebra
using Reexport: @reexport
using RecursiveArrayTools: ArrayPartition, DiffEqArray, VectorOfArray
using SciMLBase: SciMLBase, AbstractDiffEqInterpolation, StandardBVProblem, __solve,
    _unwrap_val, solve
using Setfield: @set!, @set
using SparseArrays: sparse
using OrdinaryDiffEqTsit5: Tsit5
using PrecompileTools: @compile_workload, @setup_workload
using Preferences: Preferences

const DI = DifferentiationInterface

@reexport using ADTypes, BoundaryValueDiffEqCore, SciMLBase

include("algorithms.jl")
include("single_shooting.jl")
include("multiple_shooting.jl")
include("sparse_jacobians.jl")

@setup_workload begin
    function f1!(du, u, p, t)
        du[1] = u[2]
        du[2] = 0
    end
    f1 = (u, p, t) -> [u[2], 0]

    function bc1!(residual, u, p, t)
        residual[1] = u(0.0)[1] - 5
        residual[2] = u(5.0)[1]
    end

    bc1 = (u, p, t) -> [u(0.0)[1] - 5, u(5.0)[1]]

    bc1_a! = (residual, ua, p) -> (residual[1] = ua[1] - 5)
    bc1_b! = (residual, ub, p) -> (residual[1] = ub[1])

    bc1_a = (ua, p) -> [ua[1] - 5]
    bc1_b = (ub, p) -> [ub[1]]

    tspan = (0.0, 5.0)
    u0 = [5.0, -3.5]
    bcresid_prototype = (Array{Float64}(undef, 1), Array{Float64}(undef, 1))

    probs = [
        BVProblem(f1!, bc1!, u0, tspan; nlls = Val(false)),
        BVProblem(f1, bc1, u0, tspan; nlls = Val(false)),
        TwoPointBVProblem(
            f1!, (bc1_a!, bc1_b!), u0, tspan; bcresid_prototype, nlls = Val(false)
        ),
        TwoPointBVProblem(
            f1, (bc1_a, bc1_b), u0, tspan; bcresid_prototype, nlls = Val(false)
        ),
    ]

    jac_alg = BVPJacobianAlgorithm(AutoForwardDiff(; chunksize = 2))

    algs = []

    if Preferences.@load_preference("PrecompileShooting", true)
        append!(algs, [Shooting(Tsit5(); jac_alg)])
    end

    @compile_workload begin
        @sync for prob in probs, alg in algs
            Threads.@spawn solve(prob, alg)
        end
    end

    algs = []

    if Preferences.@load_preference("PrecompileMultipleShooting", true)
        append!(algs, [MultipleShooting(5, Tsit5(); jac_alg)])
    end

    @compile_workload begin
        @sync for prob in probs, alg in algs
            Threads.@spawn solve(prob, alg)
        end
    end
end

export Shooting, MultipleShooting

end # module BoundaryValueDiffEqShooting

@testitem "Lambert's Problem" begin
    using BoundaryValueDiffEqShooting, OrdinaryDiffEqLowOrderRK, LinearAlgebra

    y0 = [
        -4.7763169762853989e+6, -3.838639870444152e+5, -5.3500183933132319e+6,
        -5528.612564911408, 1216.8442360202787, 4845.114446429901,
    ]
    init_val = [
        -4.7763169762853989e+6, -3.838639870444152e+5, -5.3500183933132319e+6,
        7.0526926403748598e+6, -7.9650476230388973e+5, -1.191112886366643e+6,
    ]
    J2 = 1.08262668e-3
    req = 6378137
    my = 398600.4418e+9
    t0 = 86400 * 2.3577475462484435e+4
    t1 = 86400 * 2.3577522023524125e+4
    tspan = (t0, t1)

    # ODE solver
    function orbital!(dy, y, p, t)
        r2 = (y[1]^2 + y[2]^2 + y[3]^2)
        r3 = r2^(3 / 2)
        w = 1 + 1.5J2 * (req * req / r2) * (1 - 5y[3] * y[3] / r2)
        w2 = 1 + 1.5J2 * (req * req / r2) * (3 - 5y[3] * y[3] / r2)
        dy[1] = y[4]
        dy[2] = y[5]
        dy[3] = y[6]
        dy[4] = -my * y[1] * w / r3
        dy[5] = -my * y[2] * w / r3
        dy[6] = -my * y[3] * w2 / r3
    end

    function bc!_generator(resid, sol, init_val)
        resid[1] = sol(t0)[1] - init_val[1]
        resid[2] = sol(t0)[2] - init_val[2]
        resid[3] = sol(t0)[3] - init_val[3]
        resid[4] = sol(t1)[1] - init_val[4]
        resid[5] = sol(t1)[2] - init_val[5]
        resid[6] = sol(t1)[3] - init_val[6]
    end

    function bc!_generator_2p_a(resid0, ua, init_val)
        resid0[1] = ua[1] - init_val[1]
        resid0[2] = ua[2] - init_val[2]
        resid0[3] = ua[3] - init_val[3]
    end
    function bc!_generator_2p_b(resid1, ub, init_val)
        resid1[1] = ub[1] - init_val[4]
        resid1[2] = ub[2] - init_val[5]
        resid1[3] = ub[3] - init_val[6]
    end

    cur_bc! = (resid, sol, p, t) -> bc!_generator(resid, sol, init_val)
    cur_bc_2point_a! = (resid, sol, p) -> bc!_generator_2p_a(resid, sol, init_val)
    cur_bc_2point_b! = (resid, sol, p) -> bc!_generator_2p_b(resid, sol, init_val)

    bvp = BVProblem(orbital!, cur_bc!, y0, tspan; nlls = Val(false))
    for autodiff in
        (
            AutoForwardDiff(; chunksize = 6), AutoFiniteDiff(; fdtype = Val(:central)),
            AutoSparse(AutoForwardDiff(; chunksize = 6)),
            AutoFiniteDiff(; fdtype = Val(:forward)), AutoSparse(AutoFiniteDiff()),
        )
        nlsolve = TrustRegion(; autodiff)

        jac_alg = BVPJacobianAlgorithm(;
            nonbc_diffmode = autodiff,
            bc_diffmode = BoundaryValueDiffEqShooting.__get_non_sparse_ad(autodiff)
        )

        sol = solve(
            bvp, Shooting(DP5(); nlsolve, jac_alg); force_dtmin = true,
            abstol = 1.0e-6, reltol = 1.0e-6, verbose = false,
            odesolve_kwargs = (; abstol = 1.0e-6, reltol = 1.0e-6, adaptive = false, dt = 10000)
        )

        @test SciMLBase.successful_retcode(sol)
        @test norm(sol.resid, Inf) < 1.0e-6

        sol = solve(
            bvp, MultipleShooting(10, DP5(); nlsolve, jac_alg);
            force_dtmin = true, abstol = 1.0e-6, reltol = 1.0e-6,
            verbose = false, odesolve_kwargs = (; abstol = 1.0e-6, reltol = 1.0e-6, adaptive = false, dt = 10000)
        )

        @test SciMLBase.successful_retcode(sol)
        @test norm(sol.resid, Inf) < 1.0e-6
    end

    bvp = TwoPointBVProblem(
        orbital!, (cur_bc_2point_a!, cur_bc_2point_b!), y0, tspan;
        bcresid_prototype = (Array{Float64}(undef, 3), Array{Float64}(undef, 3)),
        nlls = Val(false)
    )
    for autodiff in (
            AutoForwardDiff(; chunksize = 6), AutoSparse(AutoFiniteDiff()),
            AutoFiniteDiff(; fdtype = Val(:central)), AutoFiniteDiff(; fdtype = Val(:forward)),
            AutoSparse(AutoForwardDiff(; chunksize = 6)),
        )
        nlsolve = TrustRegion(; autodiff)
        jac_alg = BVPJacobianAlgorithm(; nonbc_diffmode = autodiff, bc_diffmode = autodiff)

        sol = solve(
            bvp, Shooting(DP5(); nlsolve, jac_alg); force_dtmin = true,
            abstol = 1.0e-6, reltol = 1.0e-6, verbose = false,
            odesolve_kwargs = (; abstol = 1.0e-6, reltol = 1.0e-6, adaptive = false, dt = 10000)
        )

        @test SciMLBase.successful_retcode(sol)
        @test norm(sol.resid, Inf) < 1.0e-6

        sol = solve(
            bvp, MultipleShooting(10, DP5(); nlsolve, jac_alg);
            force_dtmin = true, abstol = 1.0e-6, reltol = 1.0e-6,
            verbose = false, odesolve_kwargs = (; abstol = 1.0e-6, reltol = 1.0e-6, adaptive = false, dt = 10000)
        )

        @test SciMLBase.successful_retcode(sol)
        @test norm(sol.resid, Inf) < 1.0e-6
    end
end

function SciMLBase.__solve(
        prob::BVProblem, alg_::Shooting; abstol = 1.0e-6,
        odesolve_kwargs = (;), nlsolve_kwargs = (; abstol = abstol),
        optimize_kwargs = (; abstol = abstol), verbose = true, kwargs...
    )
    # Setup the problem
    if prob.u0 isa AbstractArray{<:Number}
        u0 = prob.u0
    elseif prob.u0 isa Number
        # Scalar BVP case
        u0 = [prob.u0]
    else
        verbose && @warn "Initial guess provided, but will be ignored for Shooting."
        u0 = __extract_u0(prob.u0, prob.p, first(prob.tspan))
    end

    alg = concretize_jacobian_algorithm(alg_, prob)
    (; diffmode) = alg.jac_alg

    bcresid_prototype, resid_size = __get_bcresid_prototype(prob, u0)
    iip = Val(isinplace(prob))
    bc, u0, u0_size = prob.f.bc, deepcopy(u0), size(u0)
    @assert (_unwrap_val(iip) || isnothing(alg_.optimize)) "Out-of-place constraints don't allow optimization solvers "
    resid_prototype = __vec(bcresid_prototype)

    # Construct the residual function
    actual_ode_kwargs = (; kwargs..., verbose, odesolve_kwargs...)
    # For TwoPointBVPs we don't need to save every step
    if prob.problem_type isa TwoPointBVProblem
        ode_kwargs = (; save_everystep = false, actual_ode_kwargs...)
    else
        ode_kwargs = (; actual_ode_kwargs...)
    end
    internal_prob = ODEProblem{_unwrap_val(iip)}(prob.f, u0, prob.tspan, prob.p)
    ode_cache_loss_fn = SciMLBase.__init(internal_prob, alg.ode_alg; ode_kwargs...)

    loss_fn = __single_shooting_make_loss(
        iip, ode_cache_loss_fn, bc, u0_size, prob.problem_type, resid_size
    )

    y_ = similar(resid_prototype)

    jac_cache = __single_shooting_make_jac_cache(iip, y_, diffmode, u0)

    ode_cache_jac_fn = __single_shooting_jacobian_ode_cache(
        internal_prob, jac_cache, __cache_trait(diffmode),
        diffmode, u0, alg.ode_alg; ode_kwargs...
    )

    loss_fnₚ = __single_shooting_make_loss_p(
        iip, prob.p, ode_cache_jac_fn, bc, u0_size, prob.problem_type, resid_size
    )

    jac_prototype = __single_shooting_compute_jac_prototype(
        iip, loss_fnₚ, y_, jac_cache, diffmode, u0
    )

    jac_fn = __single_shooting_make_jac_fn(iip, jac_cache, diffmode, loss_fnₚ, y_, jac_prototype)

    nlprob = __construct_internal_problem(
        prob, alg, loss_fn, jac_fn, jac_prototype,
        resid_prototype, u0, prob.p, length(u0), 1, nothing, iip
    )
    solve_alg = __concrete_solve_algorithm(nlprob, alg.nlsolve, alg.optimize)
    kwargs = __concrete_kwargs(alg.nlsolve, alg.optimize, nlsolve_kwargs, optimize_kwargs)
    nlsol = __internal_solve(nlprob, solve_alg; kwargs...)

    # There is no way to reinit with the same cache with different cache. But not saving
    # the internal values gives a significant speedup. So we just create a new cache
    internal_prob_final = ODEProblem{_unwrap_val(iip)}(
        prob.f, reshape(nlsol.u, u0_size), prob.tspan, prob.p
    )
    odesol = __solve(internal_prob_final, alg.ode_alg; actual_ode_kwargs...)

    return __build_solution(prob, odesol, nlsol)
end

# Helper functions with Val dispatch for type stability

# Loss function creation
function __single_shooting_make_loss(
        ::Val{true}, ode_cache, bc, u0_size, problem_type, resid_size
    )
    return @closure (
        du,
        u,
        p,
    ) -> __single_shooting_loss!(
        du, u, p, ode_cache, bc, u0_size, problem_type, resid_size
    )
end

function __single_shooting_make_loss(
        ::Val{false}, ode_cache, bc, u0_size, problem_type, resid_size
    )
    return @closure (
        u,
        p,
    ) -> __single_shooting_loss(
        u, p, ode_cache, bc, u0_size, problem_type
    )
end

# Jacobian cache creation
function __single_shooting_make_jac_cache(::Val{true}, y_, diffmode, u0)
    return DI.prepare_jacobian(nothing, y_, diffmode, vec(u0); strict = Val(false))
end

function __single_shooting_make_jac_cache(::Val{false}, y_, diffmode, u0)
    return DI.prepare_jacobian(nothing, diffmode, vec(u0); strict = Val(false))
end

# Loss function for jacobian computation (with fixed p)
function __single_shooting_make_loss_p(
        ::Val{true}, p, ode_cache, bc, u0_size, problem_type, resid_size
    )
    return @closure (
        du,
        u,
    ) -> __single_shooting_loss!(
        du, u, p, ode_cache, bc, u0_size, problem_type, resid_size
    )
end

function __single_shooting_make_loss_p(
        ::Val{false}, p, ode_cache, bc, u0_size, problem_type, resid_size
    )
    return @closure (u) -> __single_shooting_loss(
        u, p, ode_cache, bc, u0_size, problem_type
    )
end

# Jacobian prototype computation
function __single_shooting_compute_jac_prototype(
        ::Val{true}, loss_fnₚ, y_, jac_cache, diffmode, u0
    )
    return DI.jacobian(loss_fnₚ, y_, jac_cache, diffmode, vec(u0))
end

function __single_shooting_compute_jac_prototype(
        ::Val{false}, loss_fnₚ, y_, jac_cache, diffmode, u0
    )
    return DI.jacobian(loss_fnₚ, jac_cache, diffmode, vec(u0))
end

# Jacobian function creation
function __single_shooting_make_jac_fn(
        ::Val{true}, jac_cache, diffmode, loss_fnₚ, y_, jac_prototype
    )
    return @closure (
        J, u, p,
    ) -> __single_shooting_jacobian!(J, u, jac_cache, diffmode, loss_fnₚ, y_)
end

function __single_shooting_make_jac_fn(
        ::Val{false}, jac_cache, diffmode, loss_fnₚ, y_, jac_prototype
    )
    return @closure (
        u,
        p,
    ) -> __single_shooting_jacobian(
        jac_prototype, u, jac_cache, diffmode, loss_fnₚ
    )
end

# Original loss and jacobian functions

function __single_shooting_loss!(
        resid_, u0_, p, cache, bc::BC, u0_size,
        pt::TwoPointBVProblem, (resida_size, residb_size)
    ) where {BC}
    resida = @view resid_[1:prod(resida_size)]
    residb = @view resid_[(prod(resida_size) + 1):end]
    resid = (reshape(resida, resida_size), reshape(residb, residb_size))

    SciMLBase.reinit!(cache, reshape(u0_, u0_size))
    odesol = solve!(cache)

    eval_bc_residual!(resid, pt, bc, odesol, p)

    return nothing
end

function __single_shooting_loss!(
        resid_, u0_, p, cache, bc::BC, u0_size,
        pt::StandardBVProblem, resid_size
    ) where {BC}
    resid = reshape(resid_, resid_size)

    SciMLBase.reinit!(cache, reshape(u0_, u0_size))
    odesol = solve!(cache)

    eval_bc_residual!(resid, pt, bc, odesol, p)

    return nothing
end

function __single_shooting_loss(u, p, cache, bc::BC, u0_size, pt) where {BC}
    SciMLBase.reinit!(cache, reshape(u, u0_size))
    odesol = solve!(cache)
    return __vec(eval_bc_residual(pt, bc, odesol, p))
end

function __single_shooting_jacobian!(J, u, jac_cache, diffmode, loss_fn::L, fu) where {L}
    DI.jacobian!(loss_fn, fu, J, jac_cache, diffmode, __vec(u))
    return J
end

function __single_shooting_jacobian(J, u, jac_cache, diffmode, loss_fn::L) where {L}
    DI.jacobian!(loss_fn, J, jac_cache, diffmode, __vec(u))
    return J
end

function __single_shooting_jacobian_ode_cache(
        prob, jac_cache, ::NoDiffCacheNeeded, diffmode, u0, ode_alg; kwargs...
    )
    return SciMLBase.__init(remake(prob; u0), ode_alg; kwargs...)
end

function __single_shooting_jacobian_ode_cache(
        prob, jac_cache, ::DiffCacheNeeded, diffmode, u0, ode_alg; kwargs...
    )
    T_dual = eltype(overloaded_input_type(jac_cache))
    xduals = zeros(T_dual, size(u0))
    prob_ = remake(prob; u0 = reshape(xduals, size(u0)), tspan = eltype(xduals).(prob.tspan))
    return SciMLBase.__init(prob_, ode_alg; kwargs...)
end

using ReTestItems, BoundaryValueDiffEqShooting, Hwloc, InteractiveUtils

@info sprint(InteractiveUtils.versioninfo)

const GROUP = lowercase(get(ENV, "GROUP", "All"))

const RETESTITEMS_NWORKERS = parse(
    Int,
    get(
        ENV, "RETESTITEMS_NWORKERS",
        string(min(ifelse(Sys.iswindows(), 0, Hwloc.num_physical_cores()), 4))
    )
)
const RETESTITEMS_NWORKER_THREADS = parse(
    Int,
    get(
        ENV, "RETESTITEMS_NWORKER_THREADS",
        string(max(Hwloc.num_virtual_cores() ÷ max(RETESTITEMS_NWORKERS, 1), 1))
    )
)

@info "Running tests for group: $(GROUP) with $(RETESTITEMS_NWORKERS) workers"

ReTestItems.runtests(
    BoundaryValueDiffEqShooting; tags = (GROUP == "all" ? nothing : [Symbol(GROUP)]),
    nworkers = RETESTITEMS_NWORKERS, nworker_threads = RETESTITEMS_NWORKER_THREADS,
    testitem_timeout = 5 * 60 * 60
)

function SciMLBase.__solve(
        prob::BVProblem, _alg::MultipleShooting; abstol = 1.0e-6, odesolve_kwargs = (;),
        nlsolve_kwargs = (; abstol = abstol), optimize_kwargs = (; abstol = abstol),
        ensemblealg = EnsembleThreads(), verbose = true, kwargs...
    )
    verbose_spec = _process_verbose_param(verbose)

    (; f, tspan) = prob

    if !(ensemblealg isa EnsembleSerial) && !(ensemblealg isa EnsembleThreads)
        throw(ArgumentError("Currently MultipleShooting only supports `EnsembleSerial` and \
                             `EnsembleThreads`!"))
    end

    ig, T, N, Nig, u0 = __extract_problem_details(prob; dt = 0.1)
    has_initial_guess = _unwrap_val(ig)

    @assert u0 isa AbstractVector "Non-Vector Inputs for Multiple-Shooting hasn't been implemented yet!"

    bcresid_prototype, resid_size = __get_bcresid_prototype(prob, u0)
    iip, bc, u0, u0_size = isinplace(prob), prob.f.bc, deepcopy(u0), size(u0)
    @assert (iip || isnothing(_alg.optimize)) "Out-of-place constraints don't allow optimization solvers "

    __alg = concretize_jacobian_algorithm(_alg, prob)
    alg = if has_initial_guess && Nig != __alg.nshoots
        @SciMLMessage(
            "Initial guess length != `nshoots + 1`! Adapting to `nshoots = $(Nig)`",
            verbose_spec,
            :multiple_shooting_initial_guess
        )
        update_nshoots(__alg, Nig)
    else
        __alg
    end

    nshoots = alg.nshoots

    if prob.problem_type isa TwoPointBVProblem
        resida_len = prod(resid_size[1])
        residb_len = prod(resid_size[2])
        M = resida_len + residb_len
    else
        M = length(bcresid_prototype)
    end

    internal_ode_kwargs = (; verbose, kwargs..., odesolve_kwargs..., save_end = true)

    solve_internal_odes! = @closure (
        resid_nodes,
        us,
        p,
        cur_nshoot,
        nodes,
        odecache,
    ) -> __multiple_shooting_solve_internal_odes!(
        resid_nodes, us, cur_nshoot, odecache, nodes, u0_size, N, ensemblealg, tspan
    )

    # This gets all the nshoots except the final SingleShooting case
    all_nshoots = __get_all_nshoots(alg.grid_coarsening, nshoots)
    u_at_nodes, nodes = similar(u0, 0), typeof(first(tspan))[]

    ode_cache_loss_fn = __multiple_shooting_init_odecache(
        ensemblealg, prob, alg.ode_alg, u0, maximum(all_nshoots); internal_ode_kwargs...
    )

    for (i, cur_nshoot) in enumerate(all_nshoots)
        if i == 1
            u_at_nodes = __multiple_shooting_initialize!(
                nodes, prob, alg, ig, nshoots, ode_cache_loss_fn;
                kwargs..., verbose_spec, odesolve_kwargs...
            )
        else
            u_at_nodes = __multiple_shooting_initialize!(
                nodes, u_at_nodes, prob, alg, cur_nshoot, all_nshoots[i - 1], ig,
                ode_cache_loss_fn, u0; kwargs..., verbose_spec, odesolve_kwargs...
            )
        end

        if prob.problem_type isa TwoPointBVProblem
            __solve_nlproblem!(
                prob.problem_type, alg, bcresid_prototype, u_at_nodes, nodes,
                cur_nshoot, M, N, resida_len, residb_len, solve_internal_odes!, bc[1],
                bc[2], prob, u0, ode_cache_loss_fn, ensemblealg, internal_ode_kwargs;
                verbose, kwargs..., nlsolve_kwargs, optimize_kwargs...
            )
        else
            __solve_nlproblem!(
                prob.problem_type, alg, bcresid_prototype, u_at_nodes, nodes,
                cur_nshoot, M, N, prod(resid_size), solve_internal_odes!, bc, prob,
                f, u0_size, u0, ode_cache_loss_fn, ensemblealg, internal_ode_kwargs;
                verbose, kwargs..., nlsolve_kwargs, optimize_kwargs...
            )
        end
    end

    if prob.problem_type isa TwoPointBVProblem
        diffmode_shooting = __get_non_sparse_ad(alg.jac_alg.diffmode)
    else
        diffmode_shooting = __get_non_sparse_ad(alg.jac_alg.bc_diffmode)
    end

    shooting_alg = Shooting(alg.ode_alg, alg.nlsolve, alg.optimize, BVPJacobianAlgorithm(diffmode_shooting))

    single_shooting_prob = remake(prob; u0 = reshape(u_at_nodes[1:N], u0_size))
    return __solve(
        single_shooting_prob, shooting_alg; odesolve_kwargs,
        nlsolve_kwargs, optimize_kwargs, verbose, kwargs...
    )
end

# TODO: We can save even more memory by hoisting the preallocated caches for the ODEs
# TODO: out of the `__solve_nlproblem!` function and into the `__solve` function.
# TODO: But we can do it another day. Currently the gains here are quite high to justify
# TODO: waiting.

function __solve_nlproblem!(
        ::TwoPointBVProblem, alg::MultipleShooting, bcresid_prototype, u_at_nodes,
        nodes, cur_nshoot::Int, M::Int, N::Int, resida_len::Int, residb_len::Int,
        solve_internal_odes!::S, bca::B1, bcb::B2, prob, u0, ode_cache_loss_fn,
        ensemblealg, internal_ode_kwargs; kwargs...
    ) where {B1, B2, S}
    resid_prototype = vcat(bcresid_prototype[1], similar(u_at_nodes, cur_nshoot * N), bcresid_prototype[2])

    loss_fn = @closure (
        du,
        u,
        p,
    ) -> __multiple_shooting_2point_loss!(
        du, u, p, cur_nshoot, nodes, prob, solve_internal_odes!,
        resida_len, residb_len, N, bca, bcb, ode_cache_loss_fn
    )

    diffmode = if alg.jac_alg.diffmode isa AutoSparse
        sparse_jacobian_prototype = __generate_sparse_jacobian_prototype(
            alg, prob.problem_type, bcresid_prototype, u0, N, cur_nshoot
        )
        AutoSparse(
            get_dense_ad(alg.jac_alg.diffmode),
            sparsity_detector = ADTypes.KnownJacobianSparsityDetector(sparse_jacobian_prototype),
            coloring_algorithm = __default_coloring_algorithm(alg.jac_alg.diffmode)
        )
    else
        alg.jac_alg.diffmode
    end

    resid_prototype_cached = similar(resid_prototype)
    jac_cache = DI.prepare_jacobian(
        nothing, resid_prototype_cached, diffmode, u_at_nodes; strict = Val(false)
    )

    ode_cache_jac_fn = __multiple_shooting_init_jacobian_odecache(
        ensemblealg, prob, jac_cache, diffmode, alg.ode_alg,
        cur_nshoot, u0; internal_ode_kwargs...
    )

    loss_fnₚ = @closure (
        du,
        u,
    ) -> __multiple_shooting_2point_loss!(
        du, u, prob.p, cur_nshoot, nodes, prob, solve_internal_odes!,
        resida_len, residb_len, N, bca, bcb, ode_cache_jac_fn
    )
    jac_prototype = DI.jacobian(loss_fnₚ, resid_prototype, jac_cache, diffmode, u_at_nodes)

    jac_fn = @closure (
        J,
        u,
        p,
    ) -> __multiple_shooting_2point_jacobian!(
        J, u, p, jac_cache, loss_fnₚ, diffmode, resid_prototype_cached, alg
    )

    loss_function! = NonlinearFunction{true}(
        loss_fn; jac = jac_fn, resid_prototype = resid_prototype,
        jac_prototype = jac_prototype
    )

    # NOTE: u_at_nodes is updated inplace
    nlprob = __construct_internal_problem(
        prob, prob.problem_type, alg, loss_fn, jac_fn, jac_prototype,
        resid_prototype, u_at_nodes, prob.p, M, length(nodes), nothing, nothing
    )

    nlsolve_alg = __concrete_solve_algorithm(nlprob, alg.nlsolve, alg.optimize)
    # Extract verbose, nlsolve_kwargs, optimize_kwargs from merged kwargs
    verbose_val = get(kwargs, :verbose, true)
    verbose_spec = _process_verbose_param(verbose_val)
    nlsolve_kw = get(kwargs, :nlsolve_kwargs, (;))
    optimize_kw = get(kwargs, :optimize_kwargs, (;))

    # Construct kwargs with nonlinear verbosity
    concrete_kw = __concrete_kwargs(alg.nlsolve, alg.optimize, nlsolve_kw, optimize_kw, verbose_spec)

    # Filter out verbose, nlsolve_kwargs, optimize_kwargs from kwargs since they're handled
    other_kw = filter(kwargs) do (k, v)
        k ∉ (:verbose, :nlsolve_kwargs, :optimize_kwargs)
    end

    __internal_solve(nlprob, nlsolve_alg; concrete_kw..., other_kw...)

    return nothing
end

function __solve_nlproblem!(
        ::StandardBVProblem, alg::MultipleShooting, bcresid_prototype,
        u_at_nodes, nodes, cur_nshoot::Int, M::Int, N::Int, resid_len::Int,
        solve_internal_odes!::S, bc::BC, prob, f::F, u0_size, u0, ode_cache_loss_fn,
        ensemblealg, internal_ode_kwargs; kwargs...
    ) where {BC, F, S}
    resid_prototype = vcat(bcresid_prototype, similar(u_at_nodes, cur_nshoot * N))

    __resid_nodes = resid_prototype[(end - cur_nshoot * N + 1):end]
    resid_nodes = __maybe_allocate_diffcache(
        __resid_nodes, pickchunksize((cur_nshoot + 1) * N), alg.jac_alg.bc_diffmode
    )

    loss_fn = @closure (
        du,
        u,
        p,
    ) -> __multiple_shooting_mpoint_loss!(
        du, u, p, cur_nshoot, nodes, prob, solve_internal_odes!, resid_len,
        N, f, bc, u0_size, prob.tspan, alg.ode_alg, u0, ode_cache_loss_fn
    )

    # ODE Part
    nonbc_diffmode = if alg.jac_alg.nonbc_diffmode isa AutoSparse
        sparse_jacobian_prototype = __generate_sparse_jacobian_prototype(
            alg, prob.problem_type, bcresid_prototype, u0, N, cur_nshoot
        )
        AutoSparse(
            get_dense_ad(alg.jac_alg.nonbc_diffmode),
            sparsity_detector = ADTypes.KnownJacobianSparsityDetector(sparse_jacobian_prototype),
            coloring_algorithm = __default_coloring_algorithm(alg.jac_alg.nonbc_diffmode)
        )
    else
        alg.jac_alg.nonbc_diffmode
    end
    ode_jac_cache = DI.prepare_jacobian(
        nothing, similar(u_at_nodes, cur_nshoot * N),
        nonbc_diffmode, u_at_nodes; strict = Val(false)
    )
    ode_cache_ode_jac_fn = __multiple_shooting_init_jacobian_odecache(
        ensemblealg, prob, ode_jac_cache, nonbc_diffmode,
        alg.ode_alg, cur_nshoot, u0; internal_ode_kwargs...
    )

    # BC Part
    (; bc_diffmode) = alg.jac_alg
    bc_diffmode = if bc_diffmode isa AutoSparse
        get_dense_ad(alg.jac_alg.bc_diffmode)
    else
        bc_diffmode
    end
    bc_jac_cache = DI.prepare_jacobian(
        nothing, similar(bcresid_prototype), bc_diffmode, u_at_nodes; strict = Val(false)
    )
    ode_cache_bc_jac_fn = __multiple_shooting_init_jacobian_odecache(
        ensemblealg, prob, bc_jac_cache, bc_diffmode,
        alg.ode_alg, cur_nshoot, u0; internal_ode_kwargs...
    )

    # Define the functions now
    ode_fn = @closure (
        du,
        u,
    ) -> solve_internal_odes!(du, u, prob.p, cur_nshoot, nodes, ode_cache_ode_jac_fn)
    bc_fn = @closure (
        du,
        u,
    ) -> __multiple_shooting_mpoint_loss_bc!(
        du, u, prob.p, cur_nshoot, nodes, prob, solve_internal_odes!, N,
        f, bc, u0_size, prob.tspan, alg.ode_alg, u0, ode_cache_bc_jac_fn
    )

    jac_prototype_ode = DI.jacobian(
        ode_fn, similar(u_at_nodes, cur_nshoot * N),
        ode_jac_cache, nonbc_diffmode, u_at_nodes
    )
    jac_prototype_bc = DI.jacobian(
        bc_fn, similar(bcresid_prototype), bc_jac_cache, bc_diffmode, u_at_nodes
    )
    jac_prototype = vcat(sparse(jac_prototype_ode), jac_prototype_bc)

    jac_fn = @closure (
        J,
        u,
        p,
    ) -> __multiple_shooting_mpoint_jacobian!(
        J, u, p, similar(bcresid_prototype), resid_nodes, ode_jac_cache, bc_jac_cache,
        ode_fn, bc_fn, nonbc_diffmode, bc_diffmode, N, M, __cache_trait(alg.jac_alg)
    )

    # NOTE: u_at_nodes is updated inplace
    nlprob = __construct_internal_problem(
        prob, prob.problem_type, alg, loss_fn, jac_fn, jac_prototype,
        resid_prototype, u_at_nodes, prob.p, M, length(nodes), nothing, nothing
    )
    nlsolve_alg = __concrete_solve_algorithm(nlprob, alg.nlsolve, alg.optimize)

    # Extract verbose, nlsolve_kwargs, optimize_kwargs from merged kwargs
    verbose_val = get(kwargs, :verbose, true)
    verbose_spec = _process_verbose_param(verbose_val)
    nlsolve_kw = get(kwargs, :nlsolve_kwargs, (;))
    optimize_kw = get(kwargs, :optimize_kwargs, (;))

    # Construct kwargs with nonlinear verbosity
    concrete_kw = __concrete_kwargs(alg.nlsolve, alg.optimize, nlsolve_kw, optimize_kw, verbose_spec)

    # Filter out verbose, nlsolve_kwargs, optimize_kwargs from kwargs since they're handled
    other_kw = filter(kwargs) do (k, v)
        k ∉ (:verbose, :nlsolve_kwargs, :optimize_kwargs)
    end

    __solve(nlprob, nlsolve_alg; concrete_kw..., other_kw...)

    return nothing
end

function __multiple_shooting_init_odecache(
        ::EnsembleSerial, prob, alg, u0, nshoots; kwargs...
    )
    odeprob = ODEProblem{isinplace(prob)}(prob.f, u0, prob.tspan, prob.p)
    return SciMLBase.__init(odeprob, alg; kwargs...)
end

function __multiple_shooting_init_odecache(
        ::EnsembleThreads, prob, alg, u0, nshoots; kwargs...
    )
    odeprob = ODEProblem{isinplace(prob)}(prob.f, u0, prob.tspan, prob.p)
    return [
        SciMLBase.__init(odeprob, alg; kwargs...)
            for _ in 1:min(Threads.nthreads(), nshoots)
    ]
end

function __multiple_shooting_init_jacobian_odecache(
        ensemblealg, prob, jac_cache, diffmode, alg, nshoots, u; kwargs...
    )
    return __multiple_shooting_init_jacobian_odecache(
        ensemblealg, prob, jac_cache, __cache_trait(diffmode),
        diffmode, alg, nshoots, u; kwargs...
    )
end

function __multiple_shooting_init_jacobian_odecache(
        ensemblealg, prob, jac_cache, ::NoDiffCacheNeeded,
        diffmode, alg, nshoots, u; kwargs...
    )
    return __multiple_shooting_init_odecache(ensemblealg, prob, alg, u, nshoots; kwargs...)
end

function __multiple_shooting_init_jacobian_odecache(
        ensemblealg, prob, jac_cache, ::DiffCacheNeeded,
        diffmode, alg, nshoots, u; kwargs...
    )
    T_dual = eltype(overloaded_input_type(jac_cache))
    xduals = zeros(T_dual, size(u))
    return __multiple_shooting_init_odecache(
        ensemblealg, prob, alg, xduals, nshoots; kwargs...
    )
end

# Not using `EnsembleProblem` since it is hard to initialize the cache and stuff
function __multiple_shooting_solve_internal_odes!(
        resid_nodes, us, cur_nshoots::Int, odecache,
        nodes, u0_size, N::Int, ::EnsembleSerial, tspan
    )
    ts_ = Vector{Vector{typeof(first(tspan))}}(undef, cur_nshoots)
    us_ = Vector{Vector{typeof(us)}}(undef, cur_nshoots)

    for i in 1:cur_nshoots
        SciMLBase.reinit!(
            odecache, reshape(@view(us[((i - 1) * N + 1):(i * N)]), u0_size);
            t0 = nodes[i], tf = nodes[i + 1]
        )
        sol = solve!(odecache)
        us_[i] = deepcopy(sol.u)
        ts_[i] = deepcopy(sol.t)
        resid_nodes[((i - 1) * N + 1):(i * N)] .= @view(us[(i * N + 1):((i + 1) * N)]) .-
            vec(sol.u[end])
    end

    return reduce(vcat, us_), reduce(vcat, ts_)
end

function __multiple_shooting_solve_internal_odes!(
        resid_nodes, us, cur_nshoots::Int, odecache::Vector,
        nodes, u0_size, N::Int, ::EnsembleThreads, tspan
    )
    ts_ = Vector{Vector{typeof(first(tspan))}}(undef, cur_nshoots)
    us_ = Vector{Vector{typeof(us)}}(undef, cur_nshoots)

    n_splits = min(cur_nshoots, Threads.nthreads())
    n_per_chunk, n_remaining = divrem(cur_nshoots, n_splits)
    data_partition = map(1:n_splits) do i
        first = 1 + (i - 1) * n_per_chunk + ifelse(i ≤ n_remaining, i - 1, n_remaining)
        last = (first - 1) + n_per_chunk + ifelse(i <= n_remaining, 1, 0)
        return first:1:last
    end

    Threads.@threads for idx in eachindex(data_partition)
        cache = odecache[idx]
        for i in data_partition[idx]
            SciMLBase.reinit!(
                cache, reshape(@view(us[((i - 1) * N + 1):(i * N)]), u0_size);
                t0 = nodes[i], tf = nodes[i + 1]
            )
            sol = solve!(cache)
            us_[i] = deepcopy(sol.u)
            ts_[i] = deepcopy(sol.t)
            resid_nodes[((i - 1) * N + 1):(i * N)] .= @view(us[(i * N + 1):((i + 1) * N)]) .-
                vec(sol.u[end])
        end
    end

    return reduce(vcat, us_), reduce(vcat, ts_)
end

function __multiple_shooting_2point_jacobian!(
        J, us, p, jac_cache, loss_fn::F, diffmode, resid, alg::MultipleShooting
    ) where {F}
    DI.jacobian!(loss_fn, resid, J, jac_cache, diffmode, us)
    return nothing
end

function __multiple_shooting_mpoint_jacobian!(
        J, us, p, resid_bc, resid_nodes, ode_jac_cache, bc_jac_cache, ode_fn::F1, bc_fn::F2,
        nonbc_diffmode, bc_diffmode, N::Int, M::Int, ::DiffCacheNeeded
    ) where {F1, F2}
    J_bc = @view(J[1:M, :])
    J_c = @view(J[(M + 1):end, :])

    DI.jacobian!(ode_fn, resid_nodes.du, J_c, ode_jac_cache, nonbc_diffmode, us)
    DI.jacobian!(bc_fn, resid_bc, J_bc, bc_jac_cache, bc_diffmode, us)

    return nothing
end
function __multiple_shooting_mpoint_jacobian!(
        J, us, p, resid_bc, resid_nodes, ode_jac_cache, bc_jac_cache, ode_fn::F1, bc_fn::F2,
        nonbc_diffmode, bc_diffmode, N::Int, M::Int, ::NoDiffCacheNeeded
    ) where {F1, F2}
    J_bc = @view(J[1:M, :])
    J_c = @view(J[(M + 1):end, :])

    DI.jacobian!(ode_fn, resid_nodes, J_c, ode_jac_cache, nonbc_diffmode, us)
    DI.jacobian!(bc_fn, resid_bc, J_bc, bc_jac_cache, bc_diffmode, us)

    return nothing
end

@views function __multiple_shooting_2point_loss!(
        resid, us, p, cur_nshoots::Int, nodes, prob, solve_internal_odes!::S,
        resida_len, residb_len, N, bca::BCA, bcb::BCB, ode_cache
    ) where {S, BCA, BCB}
    resid_ = resid[(resida_len + 1):(end - residb_len)]
    solve_internal_odes!(resid_, us, p, cur_nshoots, nodes, ode_cache)

    resid_bc_a = resid[1:resida_len]
    resid_bc_b = resid[(end - residb_len + 1):end]

    ua = us[1:N]
    ub = us[(end - N + 1):end]

    if isinplace(prob)
        bca(resid_bc_a, ua, p)
        bcb(resid_bc_b, ub, p)
    else
        resid_bc_a .= bca(ua, p)
        resid_bc_b .= bcb(ub, p)
    end

    return nothing
end

@views function __multiple_shooting_mpoint_loss_bc!(
        resid_bc, us, p, cur_nshoots::Int, nodes, prob, solve_internal_odes!::S,
        N, f::F, bc::BC, u0_size, tspan, ode_alg, u0, ode_cache
    ) where {S, F, BC}
    iip = isinplace(prob)
    _resid_nodes = similar(us, cur_nshoots * N)

    # NOTE: We need to recompute this to correctly propagate the dual numbers / gradients
    _us, _ts = solve_internal_odes!(_resid_nodes, us, p, cur_nshoots, nodes, ode_cache)

    odeprob = ODEProblem{iip}(f, u0, tspan, p)
    total_solution = SciMLBase.build_solution(odeprob, ode_alg, _ts, _us)

    if iip
        eval_bc_residual!(resid_bc, StandardBVProblem(), bc, total_solution, p)
    else
        resid_bc .= eval_bc_residual(StandardBVProblem(), bc, total_solution, p)
    end

    return nothing
end

@views function __multiple_shooting_mpoint_loss!(
        resid, us, p, cur_nshoots::Int, nodes, prob, solve_internal_odes!::S, resid_len,
        N, f::F, bc::BC, u0_size, tspan, ode_alg, u0, ode_cache
    ) where {S, F, BC}
    iip = isinplace(prob)
    resid_bc = resid[1:resid_len]
    resid_nodes = resid[(resid_len + 1):end]

    _us, _ts = solve_internal_odes!(resid_nodes, us, p, cur_nshoots, nodes, ode_cache)

    odeprob = ODEProblem{iip}(f, u0, tspan, p)
    total_solution = SciMLBase.build_solution(odeprob, ode_alg, _ts, _us)

    if iip
        eval_bc_residual!(resid_bc, StandardBVProblem(), bc, total_solution, p)
    else
        resid_bc .= eval_bc_residual(StandardBVProblem(), bc, total_solution, p)
    end

    return nothing
end

# Problem has initial guess
@views function __multiple_shooting_initialize!(
        nodes, prob, alg, ::Val{true}, nshoots::Int, odecache; kwargs...
    )
    (; u0, tspan, p) = prob

    resize!(nodes, nshoots + 1)
    nodes .= range(tspan[1], tspan[2]; length = nshoots + 1)
    u0_ = __initial_guess_on_mesh(u0, nodes, p)

    N = length(first(u0_))
    u_at_nodes = similar(first(u0_), (nshoots + 1) * N)
    recursive_flatten!(u_at_nodes, u0_.u)

    return u_at_nodes
end

# No initial guess
@views function __multiple_shooting_initialize!(
        nodes, prob, alg::MultipleShooting, ::Val{false},
        nshoots::Int, odecache_; verbose_spec, kwargs...
    )
    (; f, u0, tspan, p) = prob
    (; ode_alg) = alg

    resize!(nodes, nshoots + 1)
    nodes .= range(tspan[1], tspan[2]; length = nshoots + 1)
    N = length(u0)

    # Ensures type stability in case the parameters are dual numbers
    if !(p isa SciMLBase.NullParameters)
        if !isconcretetype(eltype(p))
            @SciMLMessage(
                "Type inference will fail if eltype(p) is not a concrete type",
                verbose_spec,
                :type_inference
            )
        end
        u_at_nodes = similar(u0, promote_type(eltype(u0), eltype(p)), (nshoots + 1) * N)
    else
        u_at_nodes = similar(u0, (nshoots + 1) * N)
    end

    # Assumes no initial guess for now
    odecache = odecache_ isa Vector ? first(odecache_) : odecache_
    SciMLBase.reinit!(odecache, u0; t0 = tspan[1], tf = tspan[2])
    sol = solve!(odecache)

    if SciMLBase.successful_retcode(sol)
        for i in eachindex(nodes)
            u_at_nodes[(i - 1) * N .+ (1:N)] .= vec(sol(nodes[i]))
        end
    else
        @SciMLMessage(
            "Initialization using odesolve failed. Initializing using 0s. It is recommended to provide an initial guess function via `u0 = <function>(p, t)` in this case.",
            verbose_spec,
            :initialization
        )
        fill!(u_at_nodes, 0)
    end

    return u_at_nodes
end

# Grid coarsening
@views function __multiple_shooting_initialize!(
        nodes, u_at_nodes_prev, prob, alg, nshoots,
        old_nshoots, ig, odecache_, u0; kwargs...
    )
    (; f, tspan, p) = prob
    prev_nodes = copy(nodes)
    odecache = odecache_ isa Vector ? first(odecache_) : odecache_

    resize!(nodes, nshoots + 1)
    nodes .= range(tspan[1], tspan[2]; length = nshoots + 1)
    N = length(u0)

    u_at_nodes = similar(u0, N + nshoots * N)
    u_at_nodes[1:N] .= u_at_nodes_prev[1:N]
    u_at_nodes[(end - N + 1):end] .= u_at_nodes_prev[(end - N + 1):end]

    skipsize = old_nshoots / nshoots
    for i in 2:nshoots
        pos = skipsize * (i - 1) + 1
        idxs = (N + (i - 2) * N) .+ (1:N)
        if isinteger(pos)
            # If the current node is also a node of the finer grid
            ind = trunc(Int, pos)
            idxs_prev = (N + (ind - 2) * N .+ (1:N))
            u_at_nodes[idxs] .= u_at_nodes_prev[idxs_prev]
        else
            # TODO: Batch this computation and do it for all points between two nodes
            # TODO: Though it is unlikely that this will be a bottleneck
            # If the current node is not a node of the finer grid simulate from closest
            # previous node and take result from simulation
            fpos = floor(Int, pos)
            r = pos - fpos

            t0 = prev_nodes[fpos]
            tf = prev_nodes[fpos + 1]
            tstop = t0 + r * (tf - t0)

            idxs_prev = (N + (fpos - 2) * N .+ (1:N))
            ustart = u_at_nodes_prev[idxs_prev]

            SciMLBase.reinit!(odecache, ustart; t0, tf = tstop)
            odesol = solve!(odecache)

            u_at_nodes[idxs] .= odesol.u[end]
        end
    end

    return u_at_nodes
end

@inline function __get_all_nshoots(g::Bool, nshoots)
    return g ? __get_all_nshoots(Base.Fix2(÷, 2), nshoots) : [nshoots]
end
@inline function __get_all_nshoots(g, nshoots)
    first(g) == nshoots && return g
    return vcat(nshoots, g)
end
@inline function __get_all_nshoots(update_fn::G, nshoots) where {G <: Function}
    nshoots_vec = Int[nshoots]
    next = update_fn(nshoots)
    while next > 1
        push!(nshoots_vec, next)
        next = update_fn(last(nshoots_vec))
    end
    @assert !(1 in nshoots_vec)
    return nshoots_vec
end

# For Multiple Shooting
"""
    __generate_sparse_jacobian_prototype(::MultipleShooting, ::StandardBVProblem,
        bcresid_prototype, u0, N::Int, nshoots::Int)
    __generate_sparse_jacobian_prototype(::MultipleShooting, ::TwoPointBVProblem,
        bcresid_prototype, u0, N::Int, nshoots::Int)

Generate a prototype of the sparse Jacobian matrix for the BVP problem.
"""
function __generate_sparse_jacobian_prototype(
        ::MultipleShooting, ::StandardBVProblem,
        bcresid_prototype, u0, N::Int, nshoots::Int
    )
    fast_scalar_indexing(u0) ||
        error("Sparse Jacobians are only supported for Fast Scalar Index-able Arrays")
    J₁ = nshoots * N
    J₂ = (nshoots + 1) * N
    J = BandedMatrix(Ones{eltype(u0)}(J₁, J₂), (N - 1, N + 1))

    return J
end

function __generate_sparse_jacobian_prototype(
        ::MultipleShooting, ::TwoPointBVProblem,
        bcresid_prototype, u0, N::Int, nshoots::Int
    )
    fast_scalar_indexing(u0) ||
        error("Sparse Jacobians are only supported for Fast Scalar Index-able Arrays")

    resida, residb = bcresid_prototype
    L₁, L₂ = length(resida), length(residb)

    J₁ = L₁ + L₂ + nshoots * N
    J₂ = (nshoots + 1) * N

    # FIXME: There is a stronger structure than BandedMatrix here.
    #        We should be able to use that particular structure.
    J = BandedMatrix(Ones{eltype(u0)}(J₁, J₂), (max(L₁, L₂) + N - 1, N + 1))

    # for underdetermined systems we don't have banded qr implemented. use sparse
    J₁ < J₂ && return sparse(J)
    return J
end

@testitem "Overconstrained BVP" begin
    using BoundaryValueDiffEqShooting, OrdinaryDiffEqTsit5, LinearAlgebra

    # JET tests have been moved to the separate QA test group (test/qa/)

    SOLVERS = [
        Shooting(
            Tsit5(), NewtonRaphson(),
            jac_alg = BVPJacobianAlgorithm(AutoForwardDiff(; chunksize = 2))
        ),
        Shooting(
            Tsit5(), LevenbergMarquardt(;
                autodiff = AutoForwardDiff(; chunksize = 2)
            )
        ),
        Shooting(Tsit5(), LevenbergMarquardt(; autodiff = AutoFiniteDiff())),
        Shooting(Tsit5(), GaussNewton(; autodiff = AutoForwardDiff(; chunksize = 2))),
        Shooting(Tsit5(), GaussNewton(; autodiff = AutoFiniteDiff())),
        Shooting(Tsit5(), TrustRegion(; autodiff = AutoForwardDiff(; chunksize = 2))),
        Shooting(Tsit5(), TrustRegion(; autodiff = AutoFiniteDiff())),
        MultipleShooting(
            10, Tsit5(), NewtonRaphson(),
            jac_alg = BVPJacobianAlgorithm(AutoForwardDiff(; chunksize = 2))
        ),
        MultipleShooting(
            10, Tsit5(), LevenbergMarquardt(;
                autodiff = AutoForwardDiff(; chunksize = 2)
            )
        ),
        MultipleShooting(10, Tsit5(), LevenbergMarquardt(; autodiff = AutoFiniteDiff())),
        MultipleShooting(
            10, Tsit5(), GaussNewton(;
                autodiff = AutoForwardDiff(; chunksize = 2)
            )
        ),
        MultipleShooting(10, Tsit5(), GaussNewton(; autodiff = AutoFiniteDiff())),
        MultipleShooting(
            10, Tsit5(), TrustRegion(;
                autodiff = AutoForwardDiff(; chunksize = 2)
            )
        ),
        MultipleShooting(10, Tsit5(), TrustRegion(; autodiff = AutoFiniteDiff())),
    ]

    # OOP MP-BVP
    f1(u, p, t) = [u[2], -u[1]]

    function bc1(sol, p, t)
        t₁, t₂ = extrema(t)
        solₜ₁ = sol(t₁)
        solₜ₂ = sol(t₂)
        solₜ₃ = sol((t₁ + t₂) / 2)
        # We know that this overconstrained system has a solution
        return [solₜ₁[1], solₜ₂[1] - 1, solₜ₃[1] - 0.51735, solₜ₃[2] + 1.92533]
    end

    tspan = (0.0, 100.0)
    u0 = [0.0, 1.0]

    bvp1 = BVProblem(BVPFunction{false}(f1, bc1; bcresid_prototype = zeros(4)), u0, tspan; nlls = Val(true))

    for (i, solver) in enumerate(SOLVERS)
        sol = solve(
            bvp1, solver; verbose = false, abstol = 1.0e-6, reltol = 1.0e-6,
            odesolve_kwargs = (; abstol = 1.0e-6, reltol = 1.0e-6)
        )
        @test norm(sol.resid, Inf) < 0.005
    end

    # IIP MP-BVP
    function f1!(du, u, p, t)
        du[1] = u[2]
        du[2] = -u[1]
        return nothing
    end

    function bc1!(resid, sol, p, t)
        (t₁, t₂) = extrema(t)
        solₜ₁ = sol(t₁)
        solₜ₂ = sol(t₂)
        solₜ₃ = sol((t₁ + t₂) / 2)
        # We know that this overconstrained system has a solution
        resid[1] = solₜ₁[1]
        resid[2] = solₜ₂[1] - 1
        resid[3] = solₜ₃[1] - 0.51735
        resid[4] = solₜ₃[2] + 1.92533
        return nothing
    end

    bvp2 = BVProblem(BVPFunction{true}(f1!, bc1!; bcresid_prototype = zeros(4)), u0, tspan; nlls = Val(true))

    for (i, solver) in enumerate(SOLVERS)
        sol = solve(
            bvp2, solver; verbose = false, abstol = 1.0e-6, reltol = 1.0e-6,
            odesolve_kwargs = (; abstol = 1.0e-6, reltol = 1.0e-6)
        )
        @test norm(sol.resid, Inf) < 0.005
    end

    # OOP TP-BVP
    bc1a(ua, p) = [ua[1]]
    bc1b(ub, p) = [ub[1] - 1, ub[2] + 1.729109]

    bvp3 = BVProblem(
        BVPFunction{false}(
            f1, (bc1a, bc1b); twopoint = Val(true),
            bcresid_prototype = (zeros(1), zeros(2))
        ),
        u0,
        tspan;
        nlls = Val(true)
    )

    for (i, solver) in enumerate(SOLVERS)
        sol = solve(
            bvp3, solver; verbose = false, abstol = 1.0e-6, reltol = 1.0e-6,
            odesolve_kwargs = (; abstol = 1.0e-6, reltol = 1.0e-6)
        )
        @test norm(sol.resid, Inf) < 0.009
    end

    # IIP TP-BVP
    bc1a!(resid, ua, p) = (resid[1] = ua[1])
    bc1b!(resid, ub, p) = (resid[1] = ub[1] - 1; resid[2] = ub[2] + 1.729109)

    bvp4 = BVProblem(
        BVPFunction{true}(
            f1!, (bc1a!, bc1b!); twopoint = Val(true),
            bcresid_prototype = (zeros(1), zeros(2))
        ),
        u0,
        tspan;
        nlls = Val(true)
    )

    for (i, solver) in enumerate(SOLVERS)
        sol = solve(
            bvp4, solver; verbose = false, abstol = 1.0e-6, reltol = 1.0e-6,
            odesolve_kwargs = (; abstol = 1.0e-6, reltol = 1.0e-6)
        )
        @test norm(sol.resid, Inf) < 0.009
    end
end
